#ifndef __ASMSPARCV9_H__
#define __ASMSPARCV9_H__
#define FASTASM

register unsigned long hiremainder asm("%g5");
register unsigned long overflow asm("%g6");

#define addll(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "addcc %2,%3,%0; \
          or    %%g0,%%g0,%%g6; \
          movcs %%xcc,1,%%g6" \
	 : "=r" (__value), "=r" (overflow) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%g6","cc"); \
__value; })								   

#define subll(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "subcc %2,%3,%0; \
          or    %%g0,%%g0,%%g6; \
          movcs %%xcc,1,%%g6" \
	 : "=r" (__value), "=r" (overflow) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%g6","cc"); \
__value; })								   

#define addllx(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "subcc %%g0,%%g6,%%g0; \
          addccc %2,%3,%0; \
          or    %%g0,%%g0,%%g6; \
          movcs %%xcc,1,%%g6" \
	 : "=r" (__value), "=r" (overflow) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%g6","cc"); \
__value; })								   

#define subllx(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "subcc %%g0,%%g6,%%g0; \
          subccc %2,%3,%0; \
          or    %%g0,%%g0,%%g6; \
          movcs %%xcc,1,%%g6" \
	 : "=r" (__value), "=r" (overflow) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%g6","cc"); \
__value; })								   

#define shiftl(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "neg %3,%%o4; \
          srlx %2,%%o4,%1; \
          sllx %2,%3,%0" \
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%o4","%g5"); \
__value; })								   

#define shiftl2(a,b,c) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b), __arg3 = (c); \
   asm ( "srlx %2,%4,%1; \
          sllx %2,%3,%0" \
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1), "r" (__arg2), "r" (__arg3) \
         : "%g5"); \
__value; }) 			   

#define shiftlr(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "neg %3,%%o4; \
          sllx %2,%%o4,%1; \
          srlx %2,%3,%0" \
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%o4","%g5"); \
__value; }) 			   

#define shiftlr1(a) \
({ unsigned long __value, __arg1 = (a); \
   asm ( "sllx %2,63,%1; \
          srlx %2,1,%0" \
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1) \
         : "%g5"); \
__value; }) 			   

#define shiftlr2(a,b,c) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b), __arg3 = (c); \
   asm ( "sllx %2,%4,%1; \
          srlx %2,%3,%0" \
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1), "r" (__arg2), "r" (__arg3) \
         : "%g5"); \
__value; }) 			   

#define mulll(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "clruw	%2,%%o2; \
	srlx	%2,32,%%g3; \
	clruw	%3,%%o3; \
	mulx	%%o2,%%o3,%%o5; \
	srlx	%3,32,%%g4; \
	mulx	%%g3,%%g4,%%o4; \
	add	%%g3,%%o2,%%o2; \
	add	%%g4,%%o3,%%o3; \
	mulx	%%o2,%%o3,%%g4; \
	sub	%%g4,%%o5,%%g4; \
	sub	%%g4,%%o4,%%g4; \
	add	%%o2,%%o3,%%o2; \
	srlx	%%g4,32,%%o3; \
	srlx	%%o2,1,%%o2; \
	sub	%%o2,%%o3,%%o2; \
	srlx	%%o2,32,%%o2; \
	sllx	%%o2,32,%%o2; \
	add	%%o2,%%o3,%%o2; \
	add	%%o2,%%o4,%%o2; \
	sllx	%%g4,32,%%g4; \
	addcc	%%o5,%%g4,%0; \
	or	%%g0,%%g0,%%o5; \
	movcs	%%xcc,1,%%o5; \
	add	%%o2,%%o5,%1" \
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%o2","%o3","%o4","%o5","%g3","%g4","%g5","cc");  \
__value;})								   

#define addmul(a,b) \
({ unsigned long __value, __arg1 = (a), __arg2 = (b); \
   asm ( "clruw	%2,%%o2; \
	srlx	%2,32,%%o4; \
	clruw	%3,%%o3; \
	mulx	%%o2,%%o3,%%g4; \
	srlx	%3,32,%%g3; \
	mulx	%%o4,%%g3,%%o5; \
	add	%%o4,%%o2,%%o4; \
	add	%%g3,%%o3,%%o2; \
	mulx	%%o4,%%o2,%%g3; \
	add	%%o4,%%o2,%%o4; \
	sub	%%g3,%%g4,%%g3; \
	sub	%%g3,%%o5,%%g3; \
	addcc	%%g4,%%g5,%%g4; \
	or	%%g0,%%g0,%%o2; \
	movcs	%%xcc,1,%%o2; \
	add	%%o5,%%o2,%%o5; \
	srlx	%%g3,32,%%o2; \
	sllx	%%g3,32,%%g3; \
	addcc	%%g4,%%g3,%0; \
	srlx	%%o4,1,%%o4; \
	sub	%%o4,%%o2,%%o4; \
	srlx	%%o4,32,%%o4; \
	sllx	%%o4,32,%%o4; \
	add	%%o4,%%o2,%%o4; \
	add	%%o4,%%o5,%%o4; \
	or	%%g0,%%g0,%%o5; \
	movcs	%%xcc,1,%%o5; \
	add	%%o4,%%o5,%1"\
	 : "=r" (__value), "=r" (hiremainder) \
	 : "r" (__arg1), "r" (__arg2) \
         : "%o2","%o3","%o4","o5","%g3","%g4","%g5","cc");	\
__value;})								   

#endif



